<template>
	<main>
		<search-bar />

		<div ref="calendarNav" class="calendar__nav">
			<router-link custom v-slot="{ navigate }" :to="'/program/' + calendar.navPrevYear + '/' + calendar.navPrevMonth">
				<button @click="navigate" @keypress.enter="navigate" role="link" class="button calendar__nav__button">
					{{ prevMonthNameShort }}
					{{ calendar.navPrevYear }}
				</button>
			</router-link>
			<div class="calendar__nav__current-month">{{ monthNames[computedMonth - 1]}} {{ computedYear }}</div>

			<router-link custom v-slot="{ navigate }" :to="'/program/' + calendar.navNextYear + '/' + calendar.navNextMonth">
				<button @click="navigate" @keypress.enter="navigate" role="link" class="button calendar__nav__button">
					{{ nextMonthNameShort }}
					{{ calendar.navNextYear }}
				</button>
			</router-link>
		</div>

		<event-calendar :calendar="calendar" :computed-year="computedYear" :computed-month="computedMonth" :weekday-names="weekdayNames" />

		<event-preview-card v-for="(event, index) in events" :event="event" :key="index" />

		<div v-if="!events.length" class="notification-simple">
			No events this month.
		</div>

		<loader v-if="isLoading" />
	</main>

</template>

<script>
import SearchBar from "@/components/SearchBar";
import EventCalendar from "@/components/EventCalendar";
import EventPreviewCard from "@/components/EventPreviewCard";
import Loader from "@/components/Loader";

const date = new Date();

export default {
	name: "Program",
	title: "Programm",
	components: {
		Loader,
		SearchBar,
		EventCalendar,
		EventPreviewCard
	},
	data: () => ({
		isLoading: false,
		monthNames: ["Januar", "Februar", "März", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"],
		weekdayNames: ["Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag"],
		events: {},
		eventCards: [],
		calendar: {}
	}),
	methods: {
		scrollToTop() {
			if (window.innerWidth < 992)
				window.scrollTo(0, 0);
		},

		toggleCalendarNavVisuals() {
			if (window.scrollY > this.$refs.calendarNav.offsetTop - 100) {
				this.$refs.calendarNav.classList.add("calendar__nav--floaty");
			} else {
				this.$refs.calendarNav.classList.remove("calendar__nav--floaty");
			}
		},

		async fetchEvents() {
			this.isLoading = true;
			const response = await this.$http.get("/api/events/month/" + this.computedYear + "/" + this.computedMonth);
			this.events = response.data;
			this.isLoading = false;
		},

		async fetchEventCalendarData() {
			this.isLoading = true;
			const response = await this.$http.get("/api/calendar/" + this.computedYear + "/" + this.computedMonth);
			this.calendar = response.data;
			this.isLoading = false;
		}
	},

	computed: {
		computedYear() {
			return this.$route.params.year || date.getFullYear().toString();
		},
		computedMonth() {
			return this.$route.params.month || (date.getMonth() + 1).toString();
		},
		prevMonthNameShort() {
			return this.calendar.navPrevMonth
				? this.monthNames[this.calendar.navPrevMonth - 1].substr(0, 3)
				: this.monthNames[this.calendar.navPrevMonth - 1];
		},
		nextMonthNameShort() {
			return this.calendar.navNextMonth
				? this.monthNames[this.calendar.navNextMonth - 1].substr(0, 3)
				: this.monthNames[this.calendar.navNextMonth - 1];
		}
	},

	beforeMount() {
		// Month number calculated in the backend is the real world number (e.g. Jan == 1),
		// as opposed to the number you get from getMonth(), where Jan would be 0 / therefore +1
		// this.getEventCalendarData(date.getFullYear(), date.getMonth() + 1)
		// 	.then(() => window.addEventListener("scroll", this.toggleCalendarNavVisuals));
		this.fetchEventCalendarData()
			.then(() => this.fetchEvents())
			.then(() => window.addEventListener("scroll", this.toggleCalendarNavVisuals));
	},

	destroyed() {
		window.removeEventListener("scroll", this.toggleCalendarNavVisuals);
	}
}
</script>

<style>
</style>